﻿using Syncfusion.UI.Xaml.Diagram;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Stencil_Drag_Drop_Template
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            diagram.Nodes = new ObservableCollection<CustomNode>();
            (diagram.Info as IGraphInfo).ItemAdded += MainWindow_ItemAdded;

        }

        private void MainWindow_ItemAdded(object sender, ItemAddedEventArgs args)
        {
            if(args.Item is CustomNode)
            {
                CustomNode node = args.Item as CustomNode;
                node.Content = node.CustomContent;
                node.ContentTemplate = App.Current.MainWindow.Resources[node.CustomContentTemplate] as DataTemplate;
            }
        }
    }

    public class CustomNode : NodeViewModel
    {
        private string _customcontent;
        private string _customcontenttemplate;
        [DataMember]
        public string CustomContent
        {
            get
            {
                return _customcontent;
            }
            set
            {
                if (value != _customcontent)
                {
                    _customcontent = value;
                    OnPropertyChanged("CustomContent");
                }
            }
        }

        [DataMember]
        public string CustomContentTemplate
        {
            get
            {
                return _customcontenttemplate;
            }
            set
            {
                if (value != _customcontenttemplate)
                {
                    _customcontenttemplate = value;
                    OnPropertyChanged("CustomContentTemplate");
                }
            }
        }
    }
}
